SystemOrganization addCategory: #Heladeria!

TestCase subclass: #TestHelados
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:24'!
agregarBao: unEnvase
|unHelado|
unHelado := BanioChocolate new.
unHelado decorar: unEnvase.
^unHelado.! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 16:10'!
agregarGusto: unGusto a: unEnvase
unEnvase agregarGusto: unGusto.! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 10/8/2012 16:48'!
agregarLicor: unEnvase
|unHelado|
unHelado := LicorNacional new.
unHelado decorar: unEnvase.
^unHelado.! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 10/8/2012 16:48'!
agregarTopping: unEnvase
|unHelado|
unHelado := ToppingRegular new.
unHelado decorar: unEnvase.
^unHelado.! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 15:53'!
agregarToppingEspecial: unEnvase
|unHelado|
unHelado := ToppingEspecial new.
unHelado decorar: unEnvase.
^unHelado.! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 15:53'!
agregarToppingPremium: unEnvase
|unHelado|
unHelado := ToppingPremium new.
unHelado decorar: unEnvase.
^unHelado.! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 15:53'!
agregarToppingRegular: unEnvase
|unHelado|
unHelado := ToppingRegular new.
unHelado decorar: unEnvase.
^unHelado.! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 15:54'!
test01UnCucuruchoSinGustosNoEsValido
|unCucurucho|
unCucurucho := Cucurucho nuevo.
self deny: (unCucurucho valido)
! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 16:01'!
test02UnPoteDeCuartoSinGustosNoEsValido
|unHelado|
unHelado := PoteCuarto nuevo.
self deny: (unHelado valido)
! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 16:02'!
test03UnPoteDeMedioSinGustosNoEsValido
|unHelado|
unHelado := PoteMedio  nuevo.
self deny: (unHelado valido)
! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 16:02'!
test04UnPoteDeKiloSinGustosNoEsValido
|unHelado|
unHelado := PoteKilo  nuevo.
self deny: (unHelado valido)
! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 16:02'!
test05UnVasoSinGustosNoEsValido
|unHelado|
unHelado := Vaso nuevo.
self deny: (unHelado valido)
! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 16:10'!
test06UnCucuruchoCon1GustoEsValido
|unHelado|
unHelado:= Cucurucho nuevo.
unHelado := self agregarGusto: Vainilla new a: unHelado .
self assert: (unHelado valido)
! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 14:54'!
test07UnCucuruchoCon2GustosEsValido! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 14:55'!
test08UnCucuruchoCon3GustosNoEsValido! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 14:55'!
test09UnVasoCon1GustoEsValido! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 14:55'!
test10UnVasoCon2GustosEsValido! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 14:55'!
test11UnPoteCon3GustosEsValido! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 14:56'!
test12UnPoteCon1GustoEsValido! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 14:56'!
test13UnPoteCon2GustosEsValido! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 14:56'!
test14UnPoteCon3GustosEsValido! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 14:56'!
test15UnPoteCon4GustosNoEsValido! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 14:57'!
test16UnPoteCon2ToppingsNoEsValido! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 14:57'!
test17UnVasoCon2ToppingsNoEsValido! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 14:58'!
test18UnCucuruchoCon2ToppingsNoEsValido! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 14:58'!
test19UnCucuruchoCon1ToppingsNoEsValido! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 14:58'!
test20UnVasoCon1ToppingsNoEsValido! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 14:58'!
test21UnPoteCon1ToppingsNoEsValido! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 14:58'!
test22UnPoteCon3ToppingsEsValido! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 14:59'!
test23UnVasoCon3ToppingsEsValido! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 14:59'!
test24UnCucuruchoCon3ToppingsEsValido! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:00'!
test25UnCucuruchoConLicorTieneToppings! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:00'!
test26UnVasoConLicorTieneToppings! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:00'!
test27UnPoteConLicorTieneToppings! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:01'!
test28UnPoteConBaoNoEsValido! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:01'!
test29UnCucuruchoConBaoNoTieneToppings! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:01'!
test30UnVasoConBaoNoTieneToppings! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:02'!
test31UnVasoCuesta5Pesos! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:02'!
test32UnCucuruchoCuesta10Pesos! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:02'!
test33UnPoteDeCuartoCuesta20Pesos! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:03'!
test34UnPoteDeMedioCuesta35Pesos! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:03'!
test35UnPoteDeKiloCuesta65Pesos! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:03'!
test36LicorNacionalCuesta6Pesos! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:04'!
test37LicorImportadoCuesta10Pesos! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:05'!
test38BaoChocolateCuesta5Pesos! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:05'!
test39ToppingRegularCuesta1Peso! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:05'!
test40ToppingEspecialCuesta3Pesos! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:05'!
test41ToppingPremiumCuesta5Pesos! !

Object subclass: #ComponenteDeHelado
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

!ComponenteDeHelado methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:26'!
precio
^self subclassResponsibility.! !

ComponenteDeHelado subclass: #DecoradorDeHelado
	instanceVariableNames: 'decorado precio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

DecoradorDeHelado subclass: #BanioChocolate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

!DecoradorDeHelado methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:25'!
decorar: unEnvase
decorado := unEnvase.! !

!DecoradorDeHelado methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:26'!
precio
^ precio + decorado precio.! !

DecoradorDeHelado subclass: #Gusto
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

Gusto subclass: #Chocolate
	instanceVariableNames: 'nombre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

Gusto subclass: #NoGusto
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

Gusto subclass: #Vainilla
	instanceVariableNames: ''
	classVariableNames: 'nombre'
	poolDictionaries: ''
	category: 'Heladeria'!

DecoradorDeHelado subclass: #Licor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

Licor subclass: #LicorImportado
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

Licor subclass: #LicorNacional
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

DecoradorDeHelado subclass: #Topping
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

Topping subclass: #ToppingEspecial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

Topping subclass: #ToppingPremium
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

Topping subclass: #ToppingRegular
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

ToppingRegular class
	instanceVariableNames: 'precio'!

ToppingRegular class
	instanceVariableNames: 'precio'!

!ToppingRegular class methodsFor: 'as yet unclassified' stamp: 'juan 10/8/2012 16:21'!
new
precio := 5 pesos.! !

!ToppingRegular class methodsFor: 'as yet unclassified' stamp: 'juan 10/8/2012 16:24'!
nuevo
|asd|
asd := ToppingRegular new
asd setPrecio: 5.
^asd.! !

!ToppingRegular methodsFor: 'as yet unclassified' stamp: 'juan 10/8/2012 16:20'!
precio
^precio + decorado precio! !

ComponenteDeHelado subclass: #Envase
	instanceVariableNames: 'estadoValido'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

Envase subclass: #Cucurucho
	instanceVariableNames: 'gusto1 gusto2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

!Cucurucho class methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 13:56'!
deVainillaYChocolate
|unCucurucho|
unCucurucho:=Cucurucho new.
unCucurucho gusto1: Vainilla new.
unCucurucho gusto2: Chocolate new.
^unCucurucho.! !

!Cucurucho class methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 15:57'!
nuevo
	^Cucurucho new noValido.! !

!Cucurucho methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 13:58'!
gusto1: aVainilla 
	gusto1 := aVainilla! !

!Cucurucho methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 13:58'!
gusto2: aChocolate 
	gusto2 := aChocolate! !

!Cucurucho methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 15:57'!
noValido
	self valido: NoValido new.! !

!Cucurucho methodsFor: 'as yet unclassified' stamp: 'juan 10/8/2012 16:18'!
precio
^10 pesos! !

!Cucurucho methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 15:58'!
valido: aNoValido 
	estadoValido:= aNoValido .! !

!Envase methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 16:13'!
agregarGusto: aVainilla 
	(self puedeAgregarGusto)
	ifTrue: [aVainilla decorar: self]
 
	! !

!Envase methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 16:04'!
noValido
	self valido: NoValido new.! !

!Envase methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:27'!
precio
^self subclassResponsibility.! !

!Envase methodsFor: 'as yet unclassified' stamp: 'juan 10/8/2012 16:56'!
valido
	^estadoValido valor.! !

!Envase methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 16:04'!
valido: aNoValido 
	estadoValido:= aNoValido .! !

Envase subclass: #Pote
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

Pote subclass: #PoteCuarto
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

!PoteCuarto class methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 16:00'!
nuevo
	^PoteCuarto new noValido.! !

!PoteCuarto methodsFor: 'as yet unclassified' stamp: 'juan 10/8/2012 16:16'!
precio
^20 pesos! !

Pote subclass: #PoteKilo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

!PoteKilo class methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 16:00'!
nuevo
	^PoteKilo  new noValido.! !

!PoteKilo methodsFor: 'as yet unclassified' stamp: 'juan 10/8/2012 16:18'!
precio
^65 pesos! !

Pote subclass: #PoteMedio
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

!PoteMedio class methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 16:01'!
nuevo
	^PoteMedio  new noValido.! !

!PoteMedio methodsFor: 'as yet unclassified' stamp: 'juan 10/8/2012 16:18'!
precio
^35 pesos! !

Envase subclass: #Vaso
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

!Vaso class methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 16:01'!
nuevo
	^Vaso new noValido.! !

!Vaso methodsFor: 'as yet unclassified' stamp: 'juan 10/8/2012 16:18'!
precio
^5 pesos! !

Object subclass: #NoValido
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

!NoValido methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 15:59'!
valor
	^false.! !
